sys = require "luci.sys"                                           
ut = require "luci.util" 

--------------------------------------------------------------------------------------------------------
m=Map("wmbus-config","Wireless MBus Converter")

section_global = m:section(TypedSection, "global", translate("Enable/ Disable"))
section_global.anonymous = true
section_global.addremove = false
section_global.name = "global"

option_enabled = section_global:option(Flag, "enabled", translate("Enabled"),
		translate("Enable Wireless MBus"))
option_enabled.rmempty=false
option_enabled.default="1"

--Device Configuration
s = m:section(TypedSection, "wmbus_device", "WMbus Device configuration")
s.anonymous = true
s.addremove = false
s.novaluetext = translate("Device not configured yet")

serial_port = s:option(Value, "serial_port", translate("Serial Port"))
serial_port.default = "/dev/ttyHS0"

device_id = s:option(Value, "device_id", translate("Device ID"))

manufacturer = s:option(Value, "manufacturer", translate("Manufacturer"))

meter_reading_interval = s:option(Value, "meter_reading_interval", translate("Meter Reading Interval"))

--file_upload_interval = s:option(Value, "file_upload_interval", translate("File Upload Interval"))

meter_reading_timeout = s:option(Value, "meter_reading_timeout", translate("Meter Reading Timeout"))

timezone = s:option(Value, "timezone", translate("Timezone"))

--scheduled = s:option(Value, "scheduled", translate("Scheduled"))

base_folder = s:option(Value, "base_folder", translate("Base folder"))

meter_read_out = s:option(Value, "meter_read_out", translate("Meter Read Out"))

meter_read_ack = s:option(Value, "meter_read_ack", translate("Meter Read Ack"))

meter_read_out_backup = s:option(Value, "meter_read_out_backup", translate("Meter Read Out Backup"))

on_demand_read_req_in = s:option(Value, "on_demand_read_req_in", translate("On Demand Read Req in"))

on_demand_read_req_in_ack = s:option(Value, "on_demand_read_req_in_ack", translate("On Demand Read Req in Ack"))

on_demand_read_out = s:option(Value, "on_demand_read_out", translate("On Demand Read out"))

configuration_in = s:option(Value, "configuration_in", translate("Configuration In"))

configuration_out = s:option(Value, "configuration_out", translate("Configuration Out"))

configuration_in_backup = s:option(Value, "configuration_in_backup", translate("Configuration In Backup"))

dcu_events_out = s:option(Value, "dcu_events_out", translate("DCU Events out"))

dcu_events_ack = s:option(Value, "dcu_events_ack", translate("DCU Events Ack"))

dcu_events_out_backup = s:option(Value, "dcu_events_out_backup", translate("DCU Events Out Backup"))

--Meter Configuration
s2 = m:section(TypedSection, "wmbus_meter", "WMbus Meter configuration")
s2.anonymous = true
s2.addremove = true
s2.template = "cbi/tblsection"
s.novaluetext = translate("No meters configured yet")

serial_number = s2:option(Value, "serial_number", translate("Meter Serial Number"))

utility_serial_number = s2:option(Value, "utility_serial_number", translate("Utility Serial Number"))

decryption_key = s2:option(Value, "decryption_key", translate("Decryption Key"))

manufacturer = s2:option(Value, "manufacturer", translate("Manufacturer"))

return m
--------------------------------------------------------------------------------------------------------
